package gui;

import java.awt.EventQueue;
import java.awt.Font;
import java.awt.event.KeyEvent;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Timer;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import javax.swing.Action;
import javax.swing.DefaultListModel;
import javax.swing.InputMap;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JScrollBar;
import javax.swing.KeyStroke;

import javax.swing.text.AbstractDocument;

import net.ConnectionInfo;
import net.TimeoutLimitException;

import client.AuxThread;
import client.ChatThread;
import client.ClientGuiListener;
import client.FachadaClient;
import client.GrupoListThread;
import client.SendTask;
import client.UpdateListThread;


/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * ChatWindow.java
 *
 * Created on 02/06/2011, 16:01:57
 */
/**
 *
 * @author Pedro
 */
public class GroupChatWindow extends javax.swing.JFrame implements ClientGuiListener{
    private String login;
    private FachadaClient fachada;
    private Timer tim;
    private String loginCliente;
    private Hashtable<ConnectionInfo, String> tabelaDeParticipantes;
    private DefaultListModel modeloTabela;
    /** Creates new form ChatWindow */
    
    public GroupChatWindow( String loginCliente,FachadaClient fachada,Hashtable<ConnectionInfo, String> tabelaDeParticipantes,  DefaultListModel modelo) {
        this.tabelaDeParticipantes = tabelaDeParticipantes;
        tim = new Timer();
        modeloTabela = new DefaultListModel();
    	this.fachada = fachada;
        this.loginCliente = loginCliente;
        amigosList = new JList(modelo);
        ArrayList<String> coisa = Collections.list(tabelaDeParticipantes.elements());
        initComponents();
        EventQueue.invokeLater(new GrupoListThread(modeloTabela, coisa));

    }
    public void mostrarMensagem(String error) {
        JOptionPane.showMessageDialog(null, error);

    }




    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">
    private void initComponents() {
        convidarDialog = new javax.swing.JDialog();

        grupoList = new javax.swing.JList(modeloTabela);
        ScrollPane1 = new javax.swing.JScrollPane();
        areaDeChatField = new javax.swing.JTextArea();
        ScrollPane2 = new javax.swing.JScrollPane();
        mensagemField = new javax.swing.JTextArea();
        jSeparator1 = new javax.swing.JSeparator();
        enviarButton = new javax.swing.JButton();
        vozButton = new javax.swing.JButton();
        jScrollPane4 = new javax.swing.JScrollPane();
        convidarChildButton = new javax.swing.JButton();
        cancelarChildButton = new javax.swing.JButton();
        convidarButton = new javax.swing.JButton();
        loginLabel = new javax.swing.JLabel();
        statusLabel = new javax.swing.JLabel();
        ipLabel = new javax.swing.JLabel();
        Menus = new javax.swing.JMenuBar();
        jScrollPane3 = new javax.swing.JScrollPane();
        jMenu1 = new javax.swing.JMenu();
        arquivoMenuItem = new javax.swing.JMenuItem();
        setTitle("Chat");
        areaDeChatField.setAutoscrolls(true);
        areaDeChatField.setLineWrap(true);

        areaDeChatField.setColumns(20);
        areaDeChatField.setEditable(false);
        areaDeChatField.setRows(5);
        ScrollPane1.setViewportView(areaDeChatField);
        //ADICIONA ACAO DO SHIFT+ENTER
        InputMap im = mensagemField.getInputMap();
        Action acao = new NewLineAction(mensagemField);
        KeyStroke shiftEnter = KeyStroke.getKeyStroke("shift ENTER");
        im.put(shiftEnter, "shift ENTER");
        mensagemField.getActionMap().put("shift ENTER", acao);
        //REMOVE A ACAO DO ENTER
        KeyStroke remove = KeyStroke.getKeyStroke("ENTER");
        im.put(remove, "none");

        mensagemField.setColumns(20);
        mensagemField.setLineWrap(true);
        mensagemField.setRows(5);
        mensagemField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                mensagemFieldKeyPressed(evt);
            }
        });


        ScrollPane2.setViewportView(mensagemField);
        AbstractDocument doc = (AbstractDocument) mensagemField.getDocument();
        doc.setDocumentFilter(new DocumentSizeFilter(1000));

        enviarButton.setText("Enviar");
        enviarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                enviarButtonActionPerformed(evt);
            }
        });

                convidarDialog.setResizable(false);
                convidarDialog.setMinimumSize(new java.awt.Dimension(270, 440));
                
        jScrollPane4.setViewportView(amigosList);

        convidarChildButton.setText("Convidar");
        convidarChildButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                convidarChildButtonActionPerformed(evt);
            }
        });
        
        convidarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                convidarButtonActionPerformed(evt);
            }
        });

        cancelarChildButton.setText("Cancelar");
        cancelarChildButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelarChildButtonActionPerformed(evt);
            }
        });

        vozButton.setText("Voz");

        convidarButton.setText("Convidar");

        loginLabel.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N

        loginLabel.setText(login);

        statusLabel.setText("Status dele aqui");

        ipLabel.setText("IP:Porta");
        
        jScrollPane3.setViewportView(grupoList);

        jMenu1.setText("File");

        arquivoMenuItem.setText("Enviar Arquivo...");
        jMenu1.add(arquivoMenuItem);

        Menus.add(jMenu1);

        setJMenuBar(Menus);
       javax.swing.GroupLayout convidarDialogLayout = new javax.swing.GroupLayout(convidarDialog.getContentPane());
        convidarDialog.getContentPane().setLayout(convidarDialogLayout);
        convidarDialogLayout.setHorizontalGroup(
            convidarDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, convidarDialogLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(convidarDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane4, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 237, Short.MAX_VALUE)
                    .addGroup(convidarDialogLayout.createSequentialGroup()
                        .addComponent(convidarChildButton, javax.swing.GroupLayout.PREFERRED_SIZE, 114, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(cancelarChildButton, javax.swing.GroupLayout.DEFAULT_SIZE, 113, Short.MAX_VALUE)))
                .addContainerGap())
        );
        convidarDialogLayout.setVerticalGroup(
            convidarDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(convidarDialogLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane4, javax.swing.GroupLayout.PREFERRED_SIZE, 365, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(convidarDialogLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(cancelarChildButton, javax.swing.GroupLayout.DEFAULT_SIZE, 39, Short.MAX_VALUE)
                    .addComponent(convidarChildButton, javax.swing.GroupLayout.DEFAULT_SIZE, 39, Short.MAX_VALUE))
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(loginLabel)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 349, Short.MAX_VALUE)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(ipLabel)
                            .addComponent(statusLabel)))
                    .addComponent(jSeparator1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 596, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(ScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 438, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(enviarButton, javax.swing.GroupLayout.PREFERRED_SIZE, 71, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(convidarButton))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(ScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 487, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 99, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(loginLabel)
                        .addComponent(statusLabel))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(ipLabel)
                        .addGap(20, 20, 20)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(ScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 371, Short.MAX_VALUE)
                    .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 371, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(ScrollPane2, 0, 0, Short.MAX_VALUE)
                    .addComponent(enviarButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(convidarButton, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 68, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>


    private void send(){
        String msg = mensagemField.getText();
        String temp = msg.replaceAll("\n", "");
        if(!temp.equals("")){
        	SendTask task = new SendTask( fachada, this.tabelaDeParticipantes,msg,this);
        	tim.schedule(task, 0);
            mensagemField.setText("");
            areaDeChatField.append(this.loginCliente+" diz:\n"+msg+"\n");
            this.updateScroll();

        }
    }
    private void enviarButtonActionPerformed(java.awt.event.ActionEvent evt) {
        this.send();
    }
   
    
    private void convidarButtonActionPerformed(java.awt.event.ActionEvent evt) {                                              
        convidarDialog.setVisible(true);
    }                                             

    private void convidarChildButtonActionPerformed(java.awt.event.ActionEvent evt) {                                                   
        System.out.println(amigosList.getSelectedIndex());
    }                                                  

    private void cancelarChildButtonActionPerformed(java.awt.event.ActionEvent evt) {                                                   
        convidarDialog.setVisible(false);
    }  

    private void mensagemFieldKeyPressed(java.awt.event.KeyEvent evt) {
        if(!evt.isShiftDown()){
            if(evt.getKeyCode() == KeyEvent.VK_ENTER){
                this.send();

            }
        }

    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
		java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
            }
        });
    }
    // Variables declaration - do not modify
    private javax.swing.JMenuBar Menus;
    private javax.swing.JScrollPane ScrollPane1;
    private javax.swing.JScrollPane ScrollPane2;
    private javax.swing.JDialog convidarDialog;

    private javax.swing.JTextArea areaDeChatField;
    private javax.swing.JMenuItem arquivoMenuItem;
    private javax.swing.JList amigosList;

    private javax.swing.JButton convidarButton;
    private javax.swing.JButton enviarButton;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JButton convidarChildButton;
    private javax.swing.JButton cancelarChildButton;
    private javax.swing.JList grupoList;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JLabel ipLabel;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JLabel loginLabel;
    private javax.swing.JTextArea mensagemField;
    private javax.swing.JLabel statusLabel;
    private javax.swing.JButton vozButton;
    // End of variables declaration
    @Override
    public void callRecieved(ConnectionInfo ci) {
        // TODO Auto-generated method stub

    }

    @Override
    public void connectionReceived(ChatThread chat, ConnectionInfo ci) {
        // TODO Auto-generated method stub
    }

    @Override
    public void error(Exception e) {
        this.mostrarMensagem(e.getMessage());
    }

    @Override
    public void lostConnectionToServer() {
        // TODO Auto-generated method stub

    }

    @Override
    public void msgRecieved(String msg, ConnectionInfo ci, ChatThread ct) {
        System.out.println("janela recebeu mensagem "); 
        login = tabelaDeParticipantes.get(ci);
        areaDeChatField.append(login+" diz:\n"+msg+"\n");
        this.updateScroll();

        this.setVisible(true);
    }
    private void updateScroll(){
        areaDeChatField.setCaretPosition(areaDeChatField.getText().length());
    }
    @Override
    public void refreshFriendsList(Hashtable<String, ConnectionInfo> tabela) {
        // TODO Auto-generated method stub

    }

    @Override
    public void transferRecieved() {
        // TODO Auto-generated method stub

    }
    @Override
    public void initFriendsList(ArrayList<String> logins) {
        // TODO Auto-generated method stub

    }
    @Override
    public void conviteDeConversaRecebido(ConnectionInfo ci, Hashtable<ConnectionInfo, String> tabelaDeParticipantes, ChatThread chat) {
    	chat.addListener(this);
    	this.tabelaDeParticipantes.put(ci, "ahsduhas");
    }
	@Override
	public void confirmouConvite(ConnectionInfo ci, ChatThread chat) {
		
	}

}